package lockfiles;
# Lock file handling.                                             -*- perl -*-
# $Id: lockfiles.pl,v 2.1 1995/03/26 19:18:49 olaf Exp $

# Call &lockfile(base, name) e.g. &lockfile("/var/locks/LCK..", "ttyS1")
# to establish a lock. Returns 1 if locking successful, 0 if not.
# In latter case, $? is set to the PID of the holding process if locked
# by another process, negative (-errno or something) if an error occurred.

# Parameters to set: $lockfiles'maxtries: How many times to try if failed
# in-between, $lockfiles'wait: How long to wait. This does not apply if
# a lock is already there ($?>0 return).

sub main'lockfile
{
    $tmp = "$_[0].$$"; $lock = "$_[0]$_[1]";
    $locktries = 0;
    if (!open(LOCK, ">$tmp")) {
        $? = -$!; return 0;
    }
    print LOCK "$$"; close LOCK;
    while (!link($tmp, $lock)) {
        if (open(LOCK, "<$lock")) {
	    $lockpid = <LOCK>; close LOCK;
	    if (kill(0, $lockpid)) {
		unlink($tmp);
	        $? = $lockpid; return 0;
	    }
	    unlink($lock); # break stale lock
        }
        if (++$locktries > $maxtries) {
	    unlink($tmp);
	    $? = -1; return 0;
        }
        sleep $wait;
    }
    unlink($tmp);
    return 1;
}

$maxtries = 10; $wait = 2;
1;
