package mkid;
# generate a provably unique name (file, message-id)              -*- perl -*-
# $Id: mkid.pl,v 2.1 1995/03/26 19:18:49 olaf Exp $

# Call &mkid to get an unique identifier.
# If wanted, set the mode:
# &mkid'mode(0): generates names that are 13 chars and all lower case (default)
# &mkid'mode(1): generates names that are 11 chars and case sensitive

sub mode
{
    if (@_[0]) {
 $BaseChars="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ.-";
 $InBetween=","; $Bits=6; $Mask=63; $Rep=4;
    } else {
 $BaseChars="0123456789abcdefghijklmnopqrstuv";
 $InBetween="-"; $Bits=5; $Mask=31; $Rep=5;
    }
}

sub main'mkid
{
    local($t,$u) = (time>>2, ($$<<14)+(++$IntCount));
    return &base192($t).$InBetween.&base192($u);
}
# Sufficient conditions for duplicates: a PID gets reused in 4 seconds
# or: this routine is called 16384 times in 4 seconds (both unlikely...)

sub base192
# 30 bit number -> 5 or 6 char string
{
    local ($i,$j,$a) = (0,$_[0],"");
    foreach $i (0...$Rep) {
	$a .= substr($BaseChars, $j&$Mask, 1);
	$j >>= $Bits;
    }
    return $a;
}

&mode(0);
1;
