# psl-parm                                                        -*- perl -*-

# Global parameters common to the psl programs, system constants etc.
# $Id: psl-parm.pl,v 2.1 1995/03/26 19:18:49 olaf Exp $

# Where the server control directories live
$workdir  = "/var/lib/news/nntp";

# Global files and directories
$newslib  = "/var/lib/news";
$newsarts = "/var/spool/news";
$inputdir = "/var/spool/news/in.coming";

# How to get free size of a filesystem.
# Command that produces a line like this, measured in kilobytes:
# /dev/hda6             308951  278677    14827     95%   /var
# where the free size is at field $dffield ^^^ (here this is field 3)
# This command has to take an argument and output the rating of the
# given filesystem in the only line. Undef if you don't have such a beast.
$dfcommand = "/bin/df -kP %s | tail -1"; # this is for gnu df
$dffield = 3;

# Should be set in environment, but...
$hostname = `hostname`;    chop $hostname;
$logname  = getpwuid($<);

# Standard news files
$history  = "$newslib/history";
$active   = "$newslib/active";

# Files under $workdir/$server. No need to change these
$logfile  = "log";
$artfile  = "articles";
$subfile  = "subscriptions";
$sactfile = "sactive";

# constants from system headers etc., check if they are correct
$AF_INET  = 2;
$SOCK_STREAM = 1;
$WNOHANG  = 1;
$SEEK_SET = 0;
$SEEK_CUR = 1;
$SEEK_END = 2;
# these are "Assigned Numbers"
$IPPROTO_TCP = 6;
$PORT_NNTP   = 119;

umask 002; select(STDOUT); $|=1;
1;

